/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

uchar PCNCView::getbits( int i )
	{
	uchar h;
	int p;
	QString s;
	
	OK=TRUE;
	s = ncbefehlseditor->text(i);
	p = s.find( '	' ) + 1;
	s.remove( 0, p );
	s = s.stripWhiteSpace();
	if( s.isEmpty() )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Sie haben vergessen ein Bitfeld anzugeben !").arg( s ), "Fehler ");
		ncbefehlseditor->insertParagraph( "Bits	00000000", i );
		ncbefehlseditor->setCursorPosition ( i, ncbefehlseditor->paragraphLength( i ) - 1 );
		OK=FALSE;
		return 0;
		}
	
	h = 128, c = 0;
	for( int n=0; n<8; n++)
		{
		if( s.at(n)=='0' )
			h = h / 2;
		else
		if( s.at(n)=='1' )
			{
			c = c + h;
			h = h / 2;
			}
		else
			{
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zeile %1, Zeichen %2 konnte nicht entschlsselt werden !").arg( i, 0, 10 ).arg( n+p, 0, 10 ), "Fehler ");
			ncbefehlseditor->setCursorPosition ( i, p+n );
			OK=FALSE;
			return 0;
			}
		}
	schleif = schleif + 1;
	return c;
	}

uchar PCNCView::getuchar( int i )
	{
	uchar c;
	int p;
	QString s;
	
	OK=TRUE;
	s = ncbefehlseditor->text(i);
	p = s.find( '	' ) + 1;
	s.remove( 0, p );
	s = s.stripWhiteSpace();
	if( s.isEmpty() )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Sie haben vergessen einen Wert anzugeben !").arg( s ), "Fehler ");
		ncbefehlseditor->insertParagraph( "Wert	0", i );
		ncbefehlseditor->setCursorPosition ( i, ncbefehlseditor->paragraphLength( i ) - 1 );
		OK=FALSE;
		return 0;
		}
	c = StrToNum::StringToUChar( s, &OK );
	if( !OK )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
		ncbefehlseditor->setCursorPosition ( i-1, p );
		return 0;
		}
	schleif = schleif + 1;
	return c;
	}

unsigned short int PCNCView::getushort( int i )
	{
	int p;
	unsigned short int si;
	QString s;
	
	OK=TRUE;
	s = ncbefehlseditor->text(i);
	p = s.find( '	' ) + 1;
	s.remove( 0, p );
	s = s.stripWhiteSpace();
	if( s.isEmpty() )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Sie haben vergessen einen Wert anzugeben !").arg( s ), "Fehler ");
		ncbefehlseditor->insertParagraph( "Wert	0", i );
		ncbefehlseditor->setCursorPosition ( i, ncbefehlseditor->paragraphLength( i ) - 1 );
		OK=FALSE;
		return 0;
		}
	si = StrToNum::StringToUShort( s, &OK ) * mfaktor;
	if( !OK )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
		ncbefehlseditor->setCursorPosition ( i, p );
		return 0;
		}
	schleif = schleif + 2;
	return si;
	}

unsigned short int PCNCView::getushort( int i, int stellen )
	{
	int p;
	unsigned short int si;
	QString s;
	
	OK=TRUE;
	s = ncbefehlseditor->text(i);
	p = s.find( '	' ) + 1;
	s.remove( 0, p );
	s = s.stripWhiteSpace();
	if( s.isEmpty() )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Sie haben vergessen einen Wert anzugeben !").arg( s ), "Fehler ");
		ncbefehlseditor->insertParagraph( "Wert	0", i );
		ncbefehlseditor->setCursorPosition ( i, ncbefehlseditor->paragraphLength( i ) - 1 );
		OK=FALSE;
		return 0;
		}
	si = StrToNum::StringToUShort( s, &OK, stellen );
	if( !OK )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
		ncbefehlseditor->setCursorPosition ( i, p );
		return 0;
		}
	schleif = schleif + 2;
	return si;
	}

long int PCNCView::getlong( int i )
	{
	int p;
	long int l;
	QString s;
	
	OK=TRUE;
	s = ncbefehlseditor->text(i);
	p = s.find( '	' ) + 1;
	s.remove( 0, p );
	s = s.stripWhiteSpace();
	if( s.isEmpty() )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Sie haben vergessen einen Wert anzugeben !").arg( s ), "Fehler ");
		ncbefehlseditor->insertParagraph( "Wert	0", i );
		ncbefehlseditor->setCursorPosition ( i, ncbefehlseditor->paragraphLength( i ) - 1 );
		OK=FALSE;
		return 0;
		}
	l = StrToNum::StringToLong( s, &OK ) * mfaktor;
	if( !OK )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
		ncbefehlseditor->setCursorPosition ( i, p );
		return 0;
		}
	schleif = schleif + 4;
	return l;
	}

unsigned long int PCNCView::getulong( int i, uchar k=2 )
	{
	int p;
	unsigned long int ul;
	QString s;
	
	OK=TRUE;
	s = ncbefehlseditor->text(i);
	p = s.find( '	' ) + 1;
	s.remove( 0, p );
	s = s.stripWhiteSpace();
	if( s.isEmpty() )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Sie haben vergessen einen Wert anzugeben !").arg( s ), "Fehler ");
		ncbefehlseditor->insertParagraph( "Wert	0", i );
		ncbefehlseditor->setCursorPosition ( i, ncbefehlseditor->paragraphLength( i ) - 1 );
		OK=FALSE;
		return 0;
		}
	ul = StrToNum::StringToULong( s, &OK, k ) * mfaktor;
	if( !OK )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
		ncbefehlseditor->setCursorPosition ( i, p );
		return 0;
		}
	schleif = schleif + 4;
	return ul;
	}

